
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Moderation_flagsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const moderation_flags = await db.moderation_flags.create(
            {
                id: data.id || undefined,
        
        reason: data.reason
        ||
        null
            ,
            
        details: data.details
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        reported_at: data.reported_at
        ||
        null
            ,
            
        resolved_at: data.resolved_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await moderation_flags.setMedia_item( data.media_item || null, {
            transaction,
        });
        
        await moderation_flags.setReported_by( data.reported_by || null, {
            transaction,
        });
        
        await moderation_flags.setReviewed_by( data.reviewed_by || null, {
            transaction,
        });
        
        await moderation_flags.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return moderation_flags;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const moderation_flagsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                reason: item.reason
            ||
            null
            ,
            
                details: item.details
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                reported_at: item.reported_at
            ||
            null
            ,
            
                resolved_at: item.resolved_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const moderation_flags = await db.moderation_flags.bulkCreate(moderation_flagsData, { transaction });

        // For each item created, replace relation files
        

        return moderation_flags;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const moderation_flags = await db.moderation_flags.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.reason !== undefined) updatePayload.reason = data.reason;
        
        
        if (data.details !== undefined) updatePayload.details = data.details;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.reported_at !== undefined) updatePayload.reported_at = data.reported_at;
        
        
        if (data.resolved_at !== undefined) updatePayload.resolved_at = data.resolved_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await moderation_flags.update(updatePayload, {transaction});

        
        
        if (data.media_item !== undefined) {
            await moderation_flags.setMedia_item(
              
              data.media_item,
              
              { transaction }
            );
        }
        
        if (data.reported_by !== undefined) {
            await moderation_flags.setReported_by(
              
              data.reported_by,
              
              { transaction }
            );
        }
        
        if (data.reviewed_by !== undefined) {
            await moderation_flags.setReviewed_by(
              
              data.reviewed_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await moderation_flags.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return moderation_flags;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const moderation_flags = await db.moderation_flags.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of moderation_flags) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of moderation_flags) {
                await record.destroy({transaction});
            }
        });


        return moderation_flags;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const moderation_flags = await db.moderation_flags.findByPk(id, options);

        await moderation_flags.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await moderation_flags.destroy({
            transaction
        });

        return moderation_flags;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const moderation_flags = await db.moderation_flags.findOne(
            { where },
            { transaction },
        );

        if (!moderation_flags) {
            return moderation_flags;
        }

        const output = moderation_flags.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.media_item = await moderation_flags.getMedia_item({
            transaction
        });
        
        
        output.reported_by = await moderation_flags.getReported_by({
            transaction
        });
        
        
        output.reviewed_by = await moderation_flags.getReviewed_by({
            transaction
        });
        
        
        output.organizations = await moderation_flags.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.media_items,
        as: 'media_item',
        
        where: filter.media_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.media_item.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.media_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'reported_by',
        
        where: filter.reported_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reported_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.reported_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'reviewed_by',
        
        where: filter.reviewed_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reviewed_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.reviewed_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.details) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'moderation_flags',
                        'details',
                        filter.details,
                    ),
                };
            }
            

            
            

            
            if (filter.reported_atRange) {
                const [start, end] = filter.reported_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.resolved_atRange) {
                const [start, end] = filter.resolved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    resolved_at: {
                    ...where.resolved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    resolved_at: {
                    ...where.resolved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.reason) {
                where = {
                    ...where,
                reason: filter.reason,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.moderation_flags.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'moderation_flags',
                        'reason',
                        query,
                    ),
                ],
            };
        }

        const records = await db.moderation_flags.findAll({
            attributes: [ 'id', 'reason' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reason', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reason,
        }));
    }

    
};

